Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 859)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 861)
@@ -2860,378 +3008,347 @@
        i = nxl
        DO  j = nys, nyn
-       
-          IF ( boundary_flags(j,i) == 6 )  THEN
-          
-             DO  k = nzb_v_inner(j,i)+1, nzt
-                u_comp                   = u(k+1,j,i) + u(k,j,i) - gu
-                swap_flux_x_local_w(k,j) = u_comp *                           &
-                                           (w(k,j,i)+w(k,j,i-1)) * 0.25
-                swap_flux_x_local_w(k,j) = diss_2nd( w(k,j,i+2), w(k,j,i+1),  &
-                                                     w(k,j,i), w(k,j,i-1),    &
-                                                     w(k,j,i-1), u_comp,      &
-                                                     0.25, ddx )
+          DO  k = nzb+1, nzb_max
+
+             u_comp                   = u(k+1,j,i) + u(k,j,i) - gu
+             swap_flux_x_local_w(k,j) = u_comp * (                             &
+                          ( 37.0 * IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5 &
+                       +     7.0 * IBITS(wall_flags_0(k,j,i),28,1) * adv_mom_3 &
+                       +           IBITS(wall_flags_0(k,j,i),27,1) * adv_mom_1 &
+                          ) *                                                  &
+                                     ( w(k,j,i)   + w(k,j,i-1) )               &
+                   -      (  8.0 * IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5 &
+                       +           IBITS(wall_flags_0(k,j,i),28,1) * adv_mom_3 &
+                          ) *                                                  &
+                                     ( w(k,j,i+1) + w(k,j,i-2) )               &
+                   +      (        IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5 &
+                          ) *                                                  &
+                                     ( w(k,j,i+2) + w(k,j,i-3) )               &
+                                                 )
+
+               swap_diss_x_local_w(k,j) = - ABS( u_comp ) * (                  &
+                          ( 10.0 * IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5 &
+                       +     3.0 * IBITS(wall_flags_0(k,j,i),28,1) * adv_mom_3 &
+                       +           IBITS(wall_flags_0(k,j,i),27,1) * adv_mom_1 &
+                          ) *                                                  &
+                                     ( w(k,j,i)   - w(k,j,i-1) )               &
+                   -      (  5.0 * IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5 &
+                       +           IBITS(wall_flags_0(k,j,i),28,1) * adv_mom_3 &
+                          ) *                                                  &
+                                     ( w(k,j,i+1) - w(k,j,i-2) )               &
+                   +      (        IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5 &
+                          ) *                                                  &
+                                     ( w(k,j,i+2) - w(k,j,i-3) )               &
+                                                            )
+
+          ENDDO
+
+          DO  k = nzb_max+1, nzt
+
+             u_comp                   = u(k+1,j,i) + u(k,j,i) - gu
+             swap_flux_x_local_w(k,j) = u_comp * (                             &
+                            37.0 * ( w(k,j,i) + w(k,j,i-1)   )                 &
+                          -  8.0 * ( w(k,j,i+1) + w(k,j,i-2) )                 &
+                          +        ( w(k,j,i+2) + w(k,j,i-3) ) ) * adv_mom_5
+             swap_diss_x_local_w(k,j) = - ABS( u_comp ) * (                    &
+                            10.0 * ( w(k,j,i) - w(k,j,i-1)   )                 &
+                          -  5.0 * ( w(k,j,i+1) - w(k,j,i-2) )                 &
+                          +        ( w(k,j,i+2) - w(k,j,i-3) ) ) * adv_mom_5
+
+          ENDDO
+
+       ENDDO
+
+       DO i = nxl, nxr
+
+          j = nys
+          DO  k = nzb+1, nzb_max
+
+             v_comp                 = v(k+1,j,i) + v(k,j,i) - gv
+             swap_flux_y_local_w(k) = v_comp * (                              &
+                         ( 37.0 * IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5 &
+                      +     7.0 * IBITS(wall_flags_0(k,j,i),31,1) * adv_mom_3 &
+                      +           IBITS(wall_flags_0(k,j,i),30,1) * adv_mom_1 &
+                         ) *                                                  &
+                                     ( w(k,j,i)   + w(k,j-1,i) )              &
+                  -      (  8.0 * IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5 &
+                      +           IBITS(wall_flags_0(k,j,i),31,1) * adv_mom_3 &
+                         ) *                                                  &
+                                     ( w(k,j+1,i) + w(k,j-2,i) )              &
+                  +      (        IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5 &
+                         ) *                                                  &
+                                     ( w(k,j+2,i) + w(k,j-3,i) )              &
+                                               )
+
+             swap_diss_y_local_w(k) = - ABS( v_comp ) * (                     &
+                         ( 10.0 * IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5 &
+                      +     3.0 * IBITS(wall_flags_0(k,j,i),31,1) * adv_mom_3 &
+                      +           IBITS(wall_flags_0(k,j,i),30,1) * adv_mom_1 &
+                         ) *                                                  &
+                                     ( w(k,j,i)   - w(k,j-1,i) )              &
+                  -      (  5.0 * IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5 &
+                      +           IBITS(wall_flags_0(k,j,i),31,1) * adv_mom_3 &
+                         ) *                                                  &
+                                     ( w(k,j+1,i) - w(k,j-2,i) )              &
+                  +      (        IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5 &
+                         ) *                                                  &
+                                     ( w(k,j+2,i) - w(k,j-3,i) )              &
+                                                        )
+
+          ENDDO
+
+          DO  k = nzb_max+1, nzt
+
+             v_comp                 = v(k+1,j,i) + v(k,j,i) - gv
+             swap_flux_y_local_w(k) = v_comp * (                              &
+                           37.0 * ( w(k,j,i) + w(k,j-1,i)   )                 &
+                         -  8.0 * ( w(k,j+1,i) +w(k,j-2,i)  )                 &
+                         +        ( w(k,j+2,i) + w(k,j-3,i) ) ) * adv_mom_5
+             swap_diss_y_local_w(k) = - ABS( v_comp ) * (                     &
+                           10.0 * ( w(k,j,i) - w(k,j-1,i)   )                 &
+                         -  5.0 * ( w(k,j+1,i) - w(k,j-2,i) )                 &
+                         +        ( w(k,j+2,i) - w(k,j-3,i) ) ) * adv_mom_5
+
+          ENDDO
+
+          DO  j = nys, nyn
+
+             flux_t(0) = 0.0
+             diss_t(0) = 0.0
+             flux_d    = 0.0
+             diss_d    = 0.0
+
+             DO  k = nzb+1, nzb_max
+
+                u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu
+                flux_r(k) = u_comp * (                                       &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),28,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),27,1) * adv_mom_1    &
+                     ) *                                                     &
+                                 ( w(k,j,i+1) + w(k,j,i)   )                 &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),28,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( w(k,j,i+2) + w(k,j,i-1) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( w(k,j,i+3) + w(k,j,i-2) )                 &
+                                     )
+
+                diss_r(k) = - ABS( u_comp ) * (                              &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),28,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),27,1) * adv_mom_1    &
+                     ) *                                                     &
+                                 ( w(k,j,i+1) - w(k,j,i)  )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),28,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( w(k,j,i+2) - w(k,j,i-1) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),29,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( w(k,j,i+3) - w(k,j,i-2) )                 &
+                                              )
+
+                v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
+                flux_n(k) = v_comp * (                                       &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),31,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),30,1) * adv_mom_1    &
+                     ) *                                                     &
+                                 ( w(k,j+1,i) + w(k,j,i)   )                 &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),31,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( w(k,j+2,i) + w(k,j-1,i) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( w(k,j+3,i) + w(k,j-2,i) )                 &
+                                     )
+
+                diss_n(k) = - ABS( v_comp ) * (                              &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),31,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),30,1) * adv_mom_1    &
+                     ) *                                                     &
+                                 ( w(k,j+1,i) - w(k,j,i)  )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),31,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( w(k,j+2,i) - w(k,j-1,i) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),32,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( w(k,j+3,i) - w(k,j-2,i) )                 &
+                                              )
+!
+!--             k index has to be modified near bottom and top, else array
+!--             subscripts will be exceeded.
+                k_ppp = k + 3 * IBITS(wall_flags_0(k,j,i),35,1)
+                k_pp  = k + 2 * ( 1 - IBITS(wall_flags_0(k,j,i),33,1)  )
+                k_mm  = k - 2 * IBITS(wall_flags_0(k,j,i),35,1)
+
+                w_comp    = w(k+1,j,i) + w(k,j,i)
+                flux_t(k) = w_comp  * (                                      &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),34,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),33,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( w(k+1,j,i)  + w(k,j,i)     )                  &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),34,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( w(k_pp,j,i)  + w(k-1,j,i)  )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( w(k_ppp,j,i) + w(k_mm,j,i) )                  &
+                                       )
+
+                diss_t(k) = - ABS( w_comp ) * (                              &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),34,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),33,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( w(k+1,j,i)   - w(k,j,i)    )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),34,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( w(k_pp,j,i)  - w(k-1,j,i)  )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( w(k_ppp,j,i) - w(k_mm,j,i) )                  &
+                                               )
+!
+!--             Calculate the divergence of the velocity field. A respective
+!--             correction is needed to overcome numerical instabilities caused
+!--             by a not sufficient reduction of divergences near topography.
+                div = ( ( u_comp + gu - ( u(k+1,j,i) + u(k,j,i)   ) ) * ddx  &
+                    +   ( v_comp + gv - ( v(k+1,j,i) + v(k,j,i)   ) ) * ddy  &
+                    +   ( w_comp      - ( w(k,j,i)   + w(k-1,j,i) ) )        &
+                                                                 * ddzu(k+1) &
+                      ) * 0.5
+
+                tend(k,j,i) = tend(k,j,i) - (                                 &
+                      ( flux_r(k) + diss_r(k)                                 &
+                    -   swap_flux_x_local_w(k,j) - swap_diss_x_local_w(k,j)   &
+                      ) * ddx                                                 &
+                    + ( flux_n(k) + diss_n(k)                                 &
+                    -   swap_flux_y_local_w(k)   - swap_diss_y_local_w(k)     &
+                      ) * ddy                                                 &
+                    + ( flux_t(k) + diss_t(k)                                 &
+                    -   flux_d    - diss_d                                    &
+                      ) * ddzu(k+1)                                           &
+                                            )  + div * w(k,j,i)
+
+                swap_flux_x_local_w(k,j) = flux_r(k)
+                swap_diss_x_local_w(k,j) = diss_r(k)
+                swap_flux_y_local_w(k)   = flux_n(k)
+                swap_diss_y_local_w(k)   = diss_n(k)
+                flux_d                   = flux_t(k)
+                diss_d                   = diss_t(k)
+
+                sums_ws2_ws_l(k,tn)  = sums_ws2_ws_l(k,tn)                    &
+                               + ( flux_t(k) + diss_t(k) )                    &
+                               *   weight_substep(intermediate_timestep_count)
+
              ENDDO
-             
-          ELSE
-          
-             DO  k = nzb_v_inner(j,i)+1, nzt
-                u_comp                   = u(k+1,j,i) + u(k,j,i) - gu
-                swap_flux_x_local_w(k,j) = u_comp * (                          &
-                                           37.0 * ( w(k,j,i) + w(k,j,i-1)   )  &
-                                         -  8.0 * ( w(k,j,i+1) + w(k,j,i-2) )  &
-                                         +        ( w(k,j,i+2) + w(k,j,i-3) ) )&
-                                         * adv_mom_5
-                swap_diss_x_local_w(k,j) = - ABS( u_comp ) * (                 &
-                                           10.0 * ( w(k,j,i) - w(k,j,i-1)   )  &
-                                         -  5.0 * ( w(k,j,i+1) - w(k,j,i-2) )  &
-                                         +        ( w(k,j,i+2) - w(k,j,i-3) ) )&
-                                         * adv_mom_5
+
+             DO  k = nzb_max+1, nzt
+
+                u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu
+                flux_r(k) = u_comp * (                                      &
+                      37.0 * ( w(k,j,i+1) + w(k,j,i)   )                    &
+                    -  8.0 * ( w(k,j,i+2) + w(k,j,i-1) )                    &
+                    +        ( w(k,j,i+3) + w(k,j,i-2) ) ) * adv_mom_5
+
+                diss_r(k) = - ABS( u_comp ) * (                             &
+                      10.0 * ( w(k,j,i+1) - w(k,j,i)   )                    &
+                    -  5.0 * ( w(k,j,i+2) - w(k,j,i-1) )                    &
+                    +        ( w(k,j,i+3) - w(k,j,i-2) ) ) * adv_mom_5
+
+                v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
+                flux_n(k) = v_comp * (                                      &
+                      37.0 * ( w(k,j+1,i) + w(k,j,i)   )                    &
+                    -  8.0 * ( w(k,j+2,i) + w(k,j-1,i) )                    &
+                    +        ( w(k,j+3,i) + w(k,j-2,i) ) ) * adv_mom_5
+
+                diss_n(k) = - ABS( v_comp ) * (                             &
+                      10.0 * ( w(k,j+1,i) - w(k,j,i)   )                    &
+                    -  5.0 * ( w(k,j+2,i) - w(k,j-1,i) )                    &
+                    +        ( w(k,j+3,i) - w(k,j-2,i) ) ) * adv_mom_5
+!
+!--             k index has to be modified near bottom and top, else array
+!--             subscripts will be exceeded.
+                k_ppp = k + 3 * IBITS(wall_flags_0(k,j,i),35,1)
+                k_pp  = k + 2 * ( 1 - IBITS(wall_flags_0(k,j,i),33,1)  )
+                k_mm  = k - 2 * IBITS(wall_flags_0(k,j,i),35,1)
+
+                w_comp    = w(k+1,j,i) + w(k,j,i)
+                flux_t(k) = w_comp  * (                                      &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),34,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),33,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( w(k+1,j,i)  + w(k,j,i)     )                  &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),34,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( w(k_pp,j,i)  + w(k-1,j,i)  )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( w(k_ppp,j,i) + w(k_mm,j,i) )                  &
+                                      )
+
+                diss_t(k) = - ABS( w_comp ) * (                              &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),34,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),33,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( w(k+1,j,i)   - w(k,j,i)    )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),34,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( w(k_pp,j,i)  - w(k-1,j,i)  )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),35,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( w(k_ppp,j,i) - w(k_mm,j,i) )                  &
+                                              )
+!
+!--             Calculate the divergence of the velocity field. A respective
+!--             correction is needed to overcome numerical instabilities caused
+!--             by a not sufficient reduction of divergences near topography.
+                div = ( ( u_comp + gu - ( u(k+1,j,i) + u(k,j,i)   ) ) * ddx  &
+                    +   ( v_comp + gv - ( v(k+1,j,i) + v(k,j,i)   ) ) * ddy  &
+                    +   ( w_comp      - ( w(k,j,i)   + w(k-1,j,i) ) )        &
+                                                                 * ddzu(k+1) &
+                      ) * 0.5
+
+                tend(k,j,i) = tend(k,j,i) - (                                 &
+                      ( flux_r(k) + diss_r(k)                                 &
+                    -   swap_flux_x_local_w(k,j) - swap_diss_x_local_w(k,j)   &
+                      ) * ddx                                                 &
+                    + ( flux_n(k) + diss_n(k)                                 &
+                    -   swap_flux_y_local_w(k)   - swap_diss_y_local_w(k)     &
+                      ) * ddy                                                 &
+                    + ( flux_t(k) + diss_t(k)                                 &
+                    -   flux_d    - diss_d                                    &
+                      ) * ddzu(k+1)                                           &
+                                            )  + div * w(k,j,i)
+
+                swap_flux_x_local_w(k,j) = flux_r(k)
+                swap_diss_x_local_w(k,j) = diss_r(k)
+                swap_flux_y_local_w(k)   = flux_n(k)
+                swap_diss_y_local_w(k)   = diss_n(k)
+                flux_d                   = flux_t(k)
+                diss_d                   = diss_t(k)
+
+                sums_ws2_ws_l(k,tn)  = sums_ws2_ws_l(k,tn)                    &
+                               + ( flux_t(k) + diss_t(k) )                    &
+                               *   weight_substep(intermediate_timestep_count)
+
              ENDDO
-             
-          ENDIF
-          
+          ENDDO
        ENDDO
 
-       DO i = nxl, nxr
-         j = nys
-         IF ( boundary_flags(j,i) == 8 )  THEN
-         
-            DO  k = nzb_v_inner(j,i)+1, nzt
-               v_comp                 = v(k+1,j,i) + v(k,j,i) - gv
-               swap_flux_y_local_w(k) = v_comp *                               &
-                                        ( w(k,j,i) + w(k,j-1,i) ) * 0.25
-               swap_diss_y_local_w(k) = diss_2nd( w(k,j+2,i), w(k,j+1,i),      &
-                                                  w(k,j,i), w(k,j-1,i),        &
-                                                  w(k,j-1,i), v_comp, 0.25, ddy)
-            ENDDO
-            
-         ELSE
-         
-            DO  k = nzb_v_inner(j,i)+1, nzt            
-               v_comp                 = v(k+1,j,i) + v(k,j,i) - gv
-               swap_flux_y_local_w(k) = v_comp * (                             &
-                                        37.0 * ( w(k,j,i) + w(k,j-1,i)  )      &
-                                      -  8.0 * ( w(k,j+1,i) +w(k,j-2,i) )      &
-                                      +        ( w(k,j+2,i) +w(k,j-3,i) ) )    &
-                                      * adv_mom_5
-               swap_diss_y_local_w(k) = - ABS( v_comp ) * (                    &
-                                        10.0 * ( w(k,j,i) - w(k,j-1,i)   )     &
-                                      -  5.0 * ( w(k,j+1,i) - w(k,j-2,i) )     &
-                                      +        ( w(k,j+2,i) - w(k,j-3,i) ) )   &
-                                      * adv_mom_5
-            ENDDO
-            
-         ENDIF
-         
-         DO  j = nys, nyn
-
-            IF ( boundary_flags(j,i) /= 0 )  THEN
-!       
-!--            Degrade the order for Dirichlet bc. at the outflow boundary
-               SELECT CASE ( boundary_flags(j,i) )
-         
-                  CASE ( 1 )
-                     DO  k = nzb_w_inner(j,i)+1, nzt
-                        u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu
-                        flux_r(k) = u_comp * (                                &
-                                    7.0 * ( w(k,j,i+1) + w(k,j,i)   )         &
-                                  -       ( w(k,j,i+2) + w(k,j,i-1) ) )       &
-                                  * adv_mom_3
-                        diss_r(k) = -ABS( u_comp ) * (                        &
-                                    3.0 * ( w(k,j,i+1) - w(k,j,i)   )         & 
-                                  -       ( w(k,j,i+2) - w(k,j,i-1) ) )       &
-                                  * adv_mom_3  
-                     ENDDO
-               
-                  CASE ( 2 )
-                     DO  k = nzb_w_inner(j,i)+1, nzt
-                        u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu
-                        flux_r(k) = u_comp * ( w(k,j,i+1) + w(k,j,i) ) * 0.25 
-                        diss_r(k) = diss_2nd( w(k,j,i+1), w(k,j,i+1),         &
-                                              w(k,j,i), w(k,j,i-1),           &
-                                              w(k,j,i-2), u_comp, 0.25, ddx )
-                     ENDDO
-               
-                  CASE ( 3 )
-                     DO  k = nzb_w_inner(j,i)+1, nzt
-                        v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
-                        flux_n(k) = v_comp * (                                &
-                                     7.0 * ( w(k,j+1,i) + w(k,j,i)   )        &
-                                  -        ( w(k,j+2,i) + w(k,j-1,i) ) )      &
-                                  * adv_mom_3
-                        diss_n(k) = -ABS( v_comp ) * (                        &
-                                    3.0 * ( w(k,j+1,i) - w(k,j,i)   )         & 
-                                  -       ( w(k,j+2,i) - w(k,j-1,i) ) )       &
-                                  * adv_mom_3
-                     ENDDO
-               
-                  CASE ( 4 )
-                     DO  k = nzb_w_inner(j,i)+1, nzt
-                        v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
-                        flux_n(k) = v_comp * ( w(k,j+1,i) + w(k,j,i) ) * 0.25 
-                        diss_n(k) = diss_2nd( w(k,j+1,i), w(k,j+1,i),         &
-                                              w(k,j,i), w(k,j-1,i),           &
-                                              w(k,j-2,i), v_comp, 0.25, ddy )
-                     ENDDO
-               
-                  CASE ( 5 )
-                     DO  k = nzb_w_inner(j,i)+1, nzt
-                        u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu 
-                        flux_r(k) = u_comp * (                                &
-                                    7.0 * ( w(k,j,i+1) + w(k,j,i)   )         &
-                                  -       ( w(k,j,i+2) + w(k,j,i-1) ) )       &
-                                  * adv_mom_3
-                        diss_r(k) = - ABS( u_comp ) * (                       &
-                                    3.0 * ( w(k,j,i+1) - w(k,j,i) )           & 
-                                  -       ( w(k,j,i+2) - w(k,j,i-1) ) )       &
-                                  * adv_mom_3
-                     ENDDO
-               
-                  CASE ( 6 )
-                     DO  k = nzb_w_inner(j,i)+1, nzt
-                        u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu
-                        flux_r(k) = u_comp *(                                 &
-                                    7.0 * ( w(k,j,i+1) + w(k,j,i)   )         &
-                                  -       ( w(k,j,i+2) + w(k,j,i-1) ) )       &
-                                  * adv_mom_3
-                        diss_r(k) = - ABS( u_comp ) * (                       &
-                                    3.0 * ( w(k,j,i+1) - w(k,j,i) )           & 
-                                  -       ( w(k,j,i+2) - w(k,j,i-1) ) )       &
-                                  * adv_mom_3
-                     ENDDO
-               
-                  CASE ( 7 )
-                     DO  k = nzb_w_inner(j,i)+1, nzt
-                        v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
-                        flux_n(k) = v_comp *(                                 &
-                                    7.0 * ( w(k,j+1,i) + w(k,j,i)   )         &
-                                  -       ( w(k,j+2,i) + w(k,j-1,i) ) )       &
-                                  * adv_mom_3
-                        diss_n(k) = - ABS( v_comp ) * (                       &
-                                    3.0 * ( w(k,j+1,i) - w(k,j,i)   )         & 
-                                  -       ( w(k,j+2,i) - w(k,j-1,i) ) )       &
-                                  * adv_mom_3
-                      ENDDO
-                
-                  CASE ( 8 )
-                     DO  k = nzb_w_inner(j,i)+1, nzt
-                        v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
-                        flux_n(k) = v_comp * (                                &
-                                    7.0 * ( w(k,j+1,i) + w(k,j,i)   )         &
-                                  -       ( w(k,j+2,i) + w(k,j-1,i) ) )       &
-                                  * adv_mom_3
-                        diss_n(k) = - ABS( v_comp ) * (                       &
-                                    3.0 * ( w(k,j+1,i) - w(k,j,i) )           & 
-                                  -       ( w(k,j+2,i) - w(k,j-1,i) ) )       &
-                                  * adv_mom_3
-                
-                     ENDDO  
-               
-                  CASE DEFAULT
-            
-               END SELECT
-!         
-!--            Compute the crosswise 5th order fluxes at the outflow
-               IF ( boundary_flags(j,i) == 1 .OR. boundary_flags(j,i) == 2 .OR.&
-                    boundary_flags(j,i) == 5 .OR. boundary_flags(j,i) == 6 )   &
-               THEN
-         
-                  DO  k = nzb_w_inner(j,i)+1, nzt
-                     v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
-                     flux_n(k) = v_comp * (                                   &
-                                 37.0 * ( w(k,j+1,i) + w(k,j,i)   )           &
-                               -  8.0 * ( w(k,j+2,i) + w(k,j-1,i) )           &
-                               +        ( w(k,j+3,i) + w(k,j-2,i) ) )         &
-                               * adv_mom_5
-                     diss_n(k) = - ABS( v_comp ) * (                          &
-                                 10.0 * ( w(k,j+1,i) - w(k,j,i)   )           &
-                               -  5.0 * ( w(k,j+2,i) - w(k,j-1,i) )           &
-                               +        ( w(k,j+3,i) - w(k,j-2,i) ) )         &
-                               * adv_mom_5
-                  ENDDO
-            
-               ELSE
-         
-                  DO  k = nzb_w_inner(j,i)+1, nzt         
-                     u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu
-                     flux_r(k) = u_comp * (                                   &
-                                 37.0 * ( w(k,j,i+1) + w(k,j,i) )             &
-                               -  8.0 * ( w(k,j,i+2) + w(k,j,i-1) )           &
-                               +        ( w(k,j,i+3) + w(k,j,i-2) ) )         &
-                               * adv_mom_5
-                     diss_r(k) = - ABS( u_comp ) * (                          &
-                                 10.0 * ( w(k,j,i+1) - w(k,j,i)   )           &
-                               -  5.0 * ( w(k,j,i+2) - w(k,j,i-1) )           &
-                               +        ( w(k,j,i+3) - w(k,j,i-2) ) )         &
-                               * adv_mom_5
-                  ENDDO
-            
-               ENDIF
-         
-             ELSE
-!       
-!--            Compute the fifth order fluxes for the interior of PE domain.               
-               DO  k = nzb_w_inner(j,i)+1, nzt
-                  u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu
-                  flux_r(k) = u_comp * (                                      &
-                              37.0 * ( w(k,j,i+1) + w(k,j,i)   )              &
-                            -  8.0 * ( w(k,j,i+2) + w(k,j,i-1) )              &
-                            +        ( w(k,j,i+3) + w(k,j,i-2) ) )            &
-                            * adv_mom_5
-                  diss_r(k) = - ABS( u_comp ) * (                             &
-                              10.0 * ( w(k,j,i+1) - w(k,j,i)   )              &
-                            -  5.0 * ( w(k,j,i+2) - w(k,j,i-1) )              &
-                            +        ( w(k,j,i+3) - w(k,j,i-2) ) ) * adv_mom_5
-                 
-                  v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
-                  flux_n(k) = v_comp * (                                      &
-                              37.0 * ( w(k,j+1,i) + w(k,j,i)   )              &
-                            -  8.0 * ( w(k,j+2,i) + w(k,j-1,i) )              &
-                            +        ( w(k,j+3,i) + w(k,j-2,i) ) ) * adv_mom_5
-                  diss_n(k) = - ABS( v_comp ) * (                             &
-                              10.0 * ( w(k,j+1,i) - w(k,j,i)   )              &
-                            -  5.0 * ( w(k,j+2,i) - w(k,j-1,i) )              &
-                            +        ( w(k,j+3,i) - w(k,j-2,i) ) ) * adv_mom_5
-               ENDDO 
-         
-            ENDIF
-            
-            DO  k = nzb_v_inner(j,i)+1, nzt
-               tend(k,j,i) = tend(k,j,i) - (                                  &
-              ( flux_r(k) + diss_r(k)                                         &
-            -   swap_flux_x_local_w(k,j) - swap_diss_x_local_w(k,j)  ) * ddx  &
-            + ( flux_n(k) + diss_n(k)                                         &
-            -   swap_flux_y_local_w(k) - swap_diss_y_local_w(k)      ) * ddy )
-               
-               swap_flux_x_local_w(k,j) = flux_r(k)
-               swap_diss_x_local_w(k,j) = diss_r(k)
-               swap_flux_y_local_w(k)   = flux_n(k)  
-               swap_diss_y_local_w(k)   = diss_n(k)
-            ENDDO
-         ENDDO
-       ENDDO
-
-!
-!--    Vertical advection, degradation of order near surface and top. 
-!--    The fluxes flux_d and diss_d at the surface are 0. Due to reasons of
-!--    statistical evaluation the top flux at the surface should be 0
-       DO i = nxl, nxr
-          DO  j = nys, nyn
-            k      = nzb_w_inner(j,i)+1
-            flux_d = w(k-1,j,i) * ( w(k,j,i) + w(k-1,j,i))
-            flux_t(k-1) = flux_d
-            diss_d = 0.0
-            diss_t(k-1) = diss_d
-!
-!--         2nd order scheme (bottom)           
-            w_comp = w(k+1,j,i) + w(k,j,i)
-            flux_t(k) = w_comp * ( w(k+1,j,i) + w(k,j,i) ) * 0.25
-            diss_t(k) = diss_2nd( w(k+2,j,i), w(k+1,j,i), w(k,j,i), 0.0, 0.0, &
-                                  w_comp, 0.25, ddzu(k+1) )
-
-            tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)               &
-                                      -   flux_d    - diss_d      ) * ddzu(k+1)
-!                                 
-!--        WS3 as an intermediate step (bottom)
-            k         = nzb_w_inner(j,i) + 2
-            flux_d    = flux_t(k-1)
-            diss_d    = diss_t(k-1)
-            w_comp    = w(k+1,j,i) + w(k,j,i)
-            flux_t(k) = w_comp * (                                            &
-                        7.0 * ( w(k+1,j,i) + w(k,j,i) )                       &
-                      -       ( w(k+2,j,i) + w(k-1,j,i) ) ) * adv_mom_3
-            diss_t(k) = - ABS( w_comp ) * (                                   &
-                        3.0 * ( w(k+1,j,i) - w(k,j,i) )                       & 
-                      -       ( w(k+2,j,i) - w(k-1,j,i) ) ) * adv_mom_3
-                        
-            tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)               &
-                                      -   flux_d    - diss_d      ) * ddzu(k+1)
-!
-!--         WS5
-            DO  k = nzb_v_inner(j,i)+3, nzt-2
-               flux_d = flux_t(k-1)
-               diss_d = diss_t(k-1)
-
-               w_comp = w(k+1,j,i) + w(k,j,i)
-               flux_t(k) = w_comp * (                                          &
-                           37.0 * ( w(k+1,j,i) + w(k,j,i)   )                  &
-                         -  8.0 * ( w(k+2,j,i) + w(k-1,j,i) )                  &
-                         +        ( w(k+3,j,i) + w(k-2,j,i) ) ) * adv_mom_5
-               diss_t(k) = - ABS( w_comp ) * (                                 &
-                           10.0 * ( w(k+1,j,i) - w(k,j,i)   )                  & 
-                         -  5.0 * ( w(k+2,j,i) - w(k-1,j,i) )                  &
-                         +        ( w(k+3,j,i) - w(k-2,j,i) ) ) * adv_mom_5
-
-               tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)             &
-                                         -   flux_d    - diss_d    ) * ddzu(k+1)
-            ENDDO
-!                                 
-!--         WS3 as an intermediate step (top)
-            k         = nzt-1
-            flux_d    = flux_t(k-1)
-            diss_d    = diss_t(k-1)
-            w_comp    = w(k+1,j,i)+w(k,j,i)
-            flux_t(k) = w_comp * (                                            &
-                        7.0 * ( w(k+1,j,i) + w(k,j,i)   )                     &
-                      -       ( w(k+2,j,i) + w(k-1,j,i) ) ) * adv_mom_3
-            diss_t(k) = - ABS( w_comp ) * (                                   &
-                          3.0 * ( w(k+1,j,i) - w(k,j,i)   )                   & 
-                      -       ( w(k+2,j,i) - w(k-1,j,i) ) ) * adv_mom_3
-                        
-            tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)               &
-                                      -   flux_d    - diss_d      ) * ddzu(k+1)
-!
-!--         2nd order scheme (top) 
-            k = nzt
-            flux_d = flux_t(k-1)
-            diss_d = diss_t(k-1)
-            w_comp = w(k+1,j,i) + w(k,j,i)
-            flux_t(k) = w_comp * ( w(k+1,j,i) + w(k,j,i) ) * 0.25
-            diss_t(k) = diss_2nd( w(nzt+1,j,i), w(nzt+1,j,i), w(k,j,i),       &
-                                  w(k-1,j,i), w(k-2,j,i), w_comp,             &
-                                  0.25, ddzu(k+1) ) 
-
-            tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)               &
-                                      -   flux_d    - diss_d      ) * ddzu(k+1)
-!
-!--         at last vertical momentum flux is accumulated
-            DO  k = nzb_w_inner(j,i), nzt
-               sums_ws2_ws_l(k,tn)  = sums_ws2_ws_l(k,tn)                            &
-                               + ( flux_t(k) + diss_t(k) )                     &
-                               *   weight_substep(intermediate_timestep_count)
-            ENDDO
-
-          ENDDO
-       ENDDO
-
     END SUBROUTINE advec_w_ws
-    
- 
- 
-    SUBROUTINE local_diss_ij( i, j, ar, var_char )
-    
-    END SUBROUTINE local_diss_ij
-
-    SUBROUTINE local_diss( ar )
-
-
-    END SUBROUTINE local_diss
-    
-!   
-!-- Computation of 2nd order dissipation. This numerical dissipation is 
-!-- necessary to keep a stable numerical solution in regions where the
-!-- order of the schemes is degraded.
- 
-     REAL FUNCTION diss_2nd( v2, v1, v0, vm1, vm2, vel_comp, factor, grid )   &
-                            RESULT( dissip )
-        
-       IMPLICIT NONE 
-        
-       REAL, INTENT(IN)  :: v2, v1, v0, vm1, vm2, vel_comp, factor,            &
-                            grid
-
-       dissip = 0.0
-              
-    END FUNCTION diss_2nd
 
  END MODULE advec_ws
